/*
 * Created on Dec 13, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.epfl.ic.iu.x3d.jogl;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import javax.swing.JFileChooser;

import org.web3d.x3d.sai.InvalidBrowserException;
import org.web3d.x3d.sai.InvalidOperationTimingException;
import org.web3d.x3d.sai.X3DExecutionContext;
import org.web3d.x3d.sai.X3DScene;
import org.web3d.x3d.sai.rendering.X3DGeometryNode;
import org.web3d.x3d.sai.shape.X3DShapeNode;

import ch.epfl.ic.iu.x3d.helpers.X3DXMLParser;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLCanvas;
import net.java.games.jogl.GLCapabilities;
import net.java.games.jogl.GLDrawable;
import net.java.games.jogl.GLDrawableFactory;
import net.java.games.jogl.GLEventListener;
import net.java.games.jogl.GLException;
import net.java.games.jogl.GLU;
import net.java.games.jogl.impl.windows.WindowsOnscreenGLContext;

/**
 * @author ming
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class BrowserImpl {
    
    X3DSceneImpl executionContext;
    GLCanvas canvas;
    
    BrowserImpl() {
		Frame f = new Frame("Hello");
		GLCapabilities capabilities=new GLCapabilities();
        capabilities.setHardwareAccelerated(true);
        capabilities.setDoubleBuffered(true);
		canvas = GLDrawableFactory.getFactory().createGLCanvas(capabilities);
		canvas.addGLEventListener(new GLRenderer());
		f.add(canvas);
		f.setSize(500,500);
//		f.pack();
		f.show();
	    f.addWindowListener(new WindowAdapter() {
	        public void windowClosing(WindowEvent e) {
	          System.exit(0);
	        }
	      });
	    executionContext = new X3DSceneImpl();
    }

    X3DExecutionContext getExecutionContext()
    throws InvalidBrowserException,
           InvalidOperationTimingException {
        return executionContext;
    }

    
    class GLRenderer implements GLEventListener {
        public void init(GLDrawable drawable) {
            GL gl = drawable.getGL();
            gl.glEnable(GL.GL_CULL_FACE);
            gl.glEnable(GL.GL_DEPTH_TEST);
            gl.glEnable(GL.GL_NORMALIZE);
            gl.glEnable(GL.GL_LIGHTING);
            gl.glEnable(GL.GL_LIGHT0);
        }

        public void display(GLDrawable drawable) {
            GL gl = drawable.getGL();
            GLU glu = drawable.getGLU();

            gl.glLoadIdentity();
            //gl.glClearColor(100, 100, 0, 0);
            gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);

            //float red[] = { 0.8f, 0.1f, 0.0f, 1.0f };
            //gl.glMaterialfv(GL.GL_FRONT, GL.GL_AMBIENT_AND_DIFFUSE, red);
            //gl.glColor3f(1, 0, 0);
            //gl.glShadeModel(GL.GL_FLAT);
            //gl.glNormal3f(0.0f, 0.0f, -1.0f);
            
            if (executionContext != null)
                executionContext.render(gl, glu);

            /*gl.glBegin(GL.GL_POLYGON);
            gl.glVertex2f(0, 0);
            gl.glVertex2f(155, 0);
            gl.glVertex2f(0, 155);
            gl.glEnd();*/
            
            /*gl.glBegin(GL.GL_POLYGON);
            gl.glVertex3f(0, 0, -5);
            gl.glVertex3f(0, 5, -5);
            gl.glVertex3f(5, 0, -5);
            gl.glEnd();*/
            
            /*
            gl.glBegin(GL.GL_POLYGON);
            gl.glVertex3f(0, 0, -5);
            gl.glVertex3f(5, 0, -5);
            gl.glVertex3f(0, 5, -5);
            gl.glEnd();*/
            gl.glFlush();
//            canvas.swapBuffers();
        }
        boolean first = true;

        public void reshape(GLDrawable drawable, int x, int y, int w, int h) {
            GL gl = drawable.getGL();
            gl.glMatrixMode(GL.GL_PROJECTION);
            gl.glLoadIdentity();
            
            // set clipping planes at position 1.0
            gl.glFrustum(-1.0, 1.0, -1.0, 1.0, 1.0, 10000.0f);
            gl.glMatrixMode(GL.GL_MODELVIEW);
            gl.glLoadIdentity();
            //gl.glViewport (0, 0, w, h);
        }

        public void displayChanged(GLDrawable drawable, 
                boolean modeChanged, boolean deviceChanged) {}
	}
    
    public static void main(String[] args) {
    	
    	File f;
    	JFileChooser fc = new JFileChooser();
    	int returnVal = fc.showOpenDialog(null);
    	if (returnVal != JFileChooser.APPROVE_OPTION) return;
    	f = fc.getSelectedFile();
//    	f = new File("test.xml");
    	
        BrowserImpl b = new BrowserImpl();

        // Create nodes directly in the parent scene
        X3DSceneImpl scene = (X3DSceneImpl) b.getExecutionContext();

		X3DXMLParser p;
		FileReader fr = null; 
		try {
		    try {
			    fr = new FileReader(f);
				p = new X3DXMLParser(fr, scene);
				p.parse();
			} finally {
			    if (fr != null) fr.close();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
		}
//        X3DShapeNode shape = (X3DShapeNode) scene.createNode("Shape");
//        X3DGeometryNode box = (X3DGeometryNode) scene.createNode("Box");

//        shape.setGeometry(box);
//        scene.addRootNode(shape);
		
		b.canvas.repaint();
    }
}
