/*
 * Created on Dec 14, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package ch.epfl.ic.iu.x3d.jogl;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLU;
import net.java.games.jogl.GLUquadric;
import ch.epfl.ic.iu.x3d.helpers.NodeVisitor;
import ch.epfl.ic.iu.x3d.helpers.NodeVisitorHandler;
import ch.epfl.ic.iu.x3d.sai.geometry3d.BoxImpl;
import ch.epfl.ic.iu.x3d.sai.geometry3d.ConeImpl;
import ch.epfl.ic.iu.x3d.sai.geometry3d.CylinderImpl;
import ch.epfl.ic.iu.x3d.sai.geometry3d.IndexedFaceSetImpl;
import ch.epfl.ic.iu.x3d.sai.geometry3d.SphereImpl;
import ch.epfl.ic.iu.x3d.sai.grouping.GroupImpl;
import ch.epfl.ic.iu.x3d.sai.grouping.SwitchImpl;
import ch.epfl.ic.iu.x3d.sai.grouping.TransformImpl;
import ch.epfl.ic.iu.x3d.sai.shape.AppearanceImpl;
import ch.epfl.ic.iu.x3d.sai.shape.MaterialImpl;
import ch.epfl.ic.iu.x3d.sai.shape.ShapeImpl;

/**
 * @author ming
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NodeRenderer extends NodeVisitor {
    public GL gl;
    public GLU glu;
    
    void autoNormalf(float xx1, float yy1, float zz1, float xx2, float yy2, float zz2, float xx3, float yy3, float zz3) {
    	float x1 = xx1 - xx2, y1 = yy1 - yy2, z1 = zz1 - zz2;
    	float x2 = xx3 - xx2, y2 = yy3 - yy2, z2 = zz3 - zz2;
    	gl.glNormal3f(-(y1*z2-y2*z1), (x1*z2-x2*z1), -(x1*y2-x2*y1));
    }
    
    public void visitGroup(GroupImpl node) {
        for (int n = 0; n < node.children.value.length; n++) {
            ((NodeVisitorHandler)node.children.value[n]).handleVisitor(this);
        }
    }
    
    public void visitSwitch(SwitchImpl node) {
        if (node.whichChoice.value < 0 || node.whichChoice.value >= node.children.value.length) {
            ((NodeVisitorHandler)node.children.value[node.whichChoice.value]).handleVisitor(this);
        }
    }
    public void visitTransform(TransformImpl node) {
        // TODO: Use an epsilon here instead of zeros
        if (node.scale.value[0] == 0 || node.scale.value[1] == 0 || node.scale.value[2] == 0)
            return;
        
        gl.glPushMatrix();
        gl.glTranslatef(node.translation.value[0], node.translation.value[1], node.translation.value[2]);
        gl.glTranslatef(node.center.value[0], node.center.value[1], node.center.value[2]);

    	gl.glRotatef(node.rotation.value[3] / (float)Math.PI * 180, node.rotation.value[0], node.rotation.value[1], node.rotation.value[2]);
    	gl.glRotatef(node.scaleOrientation.value[3] / (float)Math.PI * 180, node.scaleOrientation.value[0], node.scaleOrientation.value[1], node.scaleOrientation.value[2]);
    	gl.glScalef(node.scale.value[0], node.scale.value[1], node.scale.value[2]);
    	gl.glRotatef(-node.scaleOrientation.value[3] / (float)Math.PI * 180, node.scaleOrientation.value[0], node.scaleOrientation.value[1], node.scaleOrientation.value[2]);
        
        gl.glTranslatef(-node.center.value[0], -node.center.value[1], -node.center.value[2]);
        for (int n = 0; n < node.children.value.length; n++) {
            ((NodeVisitorHandler)node.children.value[n]).handleVisitor(this);
        }
        gl.glPopMatrix();
    }
    public void visitShape(ShapeImpl node) {
        // I'm not sure if it's possible to save the current material state.
        // In any case, I'm not sure it's possible to have nested material
        // properties in X3D, so I'll ignore for now.

        if (node.appearance.value == null) {
            // I forget whether the spec says should happen if an appearance is undefined
            gl.glEnable(GL.GL_LIGHTING);
            gl.glShadeModel(GL.GL_SMOOTH);
//            float red[] = { 0.8f, 0.1f, 0.0f, 1.0f };
        	float white[] = { 1.0f, 1.0f, 1.0f, 1.0f};
            gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT_AND_DIFFUSE, white);
        } else {
            ((NodeVisitorHandler)node.appearance.value).handleVisitor(this);
        }
        if (node.geometry.value != null)
            ((NodeVisitorHandler)node.geometry.value).handleVisitor(this);
    }
    public void visitAppearance(AppearanceImpl node) {
        if (node.material.value != null) {
            gl.glEnable(GL.GL_LIGHTING);
            ((NodeVisitorHandler)node.material.value).handleVisitor(this);
        } else {
            // Disable lighting
            gl.glDisable(GL.GL_LIGHTING);
        	float white[] = { 1.0f, 1.0f, 1.0f, 1.0f};
            gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_DIFFUSE, white);
        }
    }
    
    public void visitMaterial(MaterialImpl node) {
        float [] color = {0, 0, 0, node.transparency.value};
        color[0] = node.ambientIntensity.value * node.diffuseColor.value[0]; color[1] = node.ambientIntensity.value * node.diffuseColor.value[1]; color[2] = node.ambientIntensity.value * node.diffuseColor.value[2];
        gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT, color);
        color[0] = node.diffuseColor.value[0]; color[1] = node.diffuseColor.value[1]; color[2] = node.diffuseColor.value[2];
        gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_DIFFUSE, color);
        color[0] = node.emissiveColor.value[0]; color[1] = node.emissiveColor.value[1]; color[2] = node.emissiveColor.value[2];
        gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_EMISSION, color);
        float [] shininess = {node.shininess.value};
        gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SHININESS, shininess);
        color[0] = node.specularColor.value[0]; color[1] = node.specularColor.value[1]; color[2] = node.specularColor.value[2];
        gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SPECULAR, color);
    }
    
    public void visitBox(BoxImpl node) {
        gl.glPushMatrix();

        gl.glScalef(node.size.value[0] / 2, node.size.value[1] / 2, node.size.value[2] / 2);
        
        renderFloatGeometry(FloatGeometry.MakeBox(node));

        gl.glPopMatrix();
    }
    public void visitCylinder(CylinderImpl node) {
        gl.glPushMatrix();

        gl.glScalef(node.radius.value, node.height.value / 2, node.radius.value);
        
        renderFloatGeometry(FloatGeometry.MakeCylinder(node));

        gl.glPopMatrix();
    }
    public void visitCone(ConeImpl node) {
        gl.glPushMatrix();

        gl.glScalef(node.bottomRadius.value, node.height.value / 2, node.bottomRadius.value);
        
        renderFloatGeometry(FloatGeometry.MakeCone(node));

        gl.glPopMatrix();	
    }
	public void visitSphere(SphereImpl node) {
        gl.glPushMatrix();

        gl.glScalef(node.radius.value, node.radius.value, node.radius.value);
        
        renderFloatGeometry(FloatGeometry.MakeSphere(node));

        gl.glPopMatrix();	
	}
    
    public void visitIndexedFaceSet(IndexedFaceSetImpl node) {
        renderFloatGeometry(FloatGeometry.MakeFaceSet(node));
    }

    void renderFloatGeometry(FloatGeometry.Model m) {
        if (m == null) return;
        gl.glBegin(GL.GL_TRIANGLES);
        if (m.normals != null) {
	        for (int n = 0; n < m.positions.length; n+=3*3) {
	            gl.glNormal3f( m.normals[n+0], m.normals[n+1], m.normals[n+2]);
	            gl.glVertex3f( m.positions[n+0], m.positions[n+1], m.positions[n+2]);
	            gl.glNormal3f( m.normals[n+3], m.normals[n+4], m.normals[n+5]);
	            gl.glVertex3f( m.positions[n+3], m.positions[n+4], m.positions[n+5]);
	            gl.glNormal3f( m.normals[n+6], m.normals[n+7], m.normals[n+8]);
	            gl.glVertex3f( m.positions[n+6], m.positions[n+7], m.positions[n+8]);
	        }
        } else {
	        for (int n = 0; n < m.positions.length; n+=3*3) {
	            autoNormalf(m.positions[n+0], m.positions[n+1], m.positions[n+2],
	            	m.positions[n+3], m.positions[n+4], m.positions[n+5],
	            	m.positions[n+6], m.positions[n+7], m.positions[n+8]);
	            gl.glVertex3f( m.positions[n+0], m.positions[n+1], m.positions[n+2]);
	            gl.glVertex3f( m.positions[n+3], m.positions[n+4], m.positions[n+5]);
	            gl.glVertex3f( m.positions[n+6], m.positions[n+7], m.positions[n+8]);
	        }
        }
        gl.glEnd();
    }
    
}
